Sub ONJOIN(Nickname,Host,Channel,ServerNumber)
checkchannel = GetIniFile("trivia.ini","controls","channel","")
if len(checkchannel) > 0 then
  if lcase(Checkchannel) = lcase(channel) then
    if lcase(nickname) <> lcase(mynickname) then
      SendCommand "/notice " & nickname & " Welcome to " & channel & "! Are you ready for a Friendly Game of trivia?", servernumber
      SendCommand "/notice " & nickname & " Type !ask to see the current question. Type /msg " & mynickname & " !answer <answer> to answer the current question.", servernumber
      SendCommand "/notice " & nickname & " Type !score to view your Current score. Type !score <nickname> to view someone elses score. Type !highscore to see the Highscore.", servernumber
      SendCommand "/notice " & nickname & " Type !help to view this message again.", servernumber
    end if
  end if
end if
End Sub

Sub ONTEXT(Message,Channel,Nickname,Host,ServerNumber)
checkchannel = GetIniFile("trivia.ini","controls","channel","")
if len(checkchannel) > 0 then
  if lcase(Checkchannel) = lcase(channel) then
    if lcase(Message) = "!ask" then
      checkwait = GetIniFile("trivia.ini","controls","wait","stop")
      if lcase(checkwait) = "stop" then
        roundinterval = GetIniFile("trivia.ini","controls","roundinterval","0")
        SendCommand "/notice " & nickname & " Next round in less than " & roundinterval & " seconds.", servernumber
      else
        num = GetIniFile("trivia.ini","controls","current","0")
        question = GetIniFile("trivia.ini","questions","" & num & "","No Questions loaded at This time.")
        SendCommand "/notice " & nickname & " " & question,servernumber
      end if
    end if
    if lcase(Message) = "!help" then
      SendCommand "/notice " & nickname & " Type !ask to see the current question. Type /msg " & mynickname & " !answer <answer> to answer the current question.", servernumber
      SendCommand "/notice " & nickname & " Type !score to view your Current score. Type !score <nickname> to view someone elses score.", servernumber
      SendCommand "/notice " & nickname & " Type !help to view this message again.", servernumber
    end if
    if lcase(message) = "!highscore" then
      highnick = getinifile("trivia.ini","controls","highnick","~None~")
      highscore = getinifile("trivia.ini","controls","highscore","0")
      SendCommand "/msg " & channel & " " & highnick & " " & highscore,servernumber
    end if
    if left(lcase(Message),6) = "!score" then
      if len(Message) > 7 then
        score = GetIniFile("trivia.ini","scores",mid(lcase(message),8),"0")
        SendCommand "/msg " & channel & " " & mid(message,8) & "'s Score: " & score,servernumber
      else
        score = GetIniFile("trivia.ini","scores",lcase(nickname),"0")
        SendCommand "/notice " & nickname & " Your Score: " & score,servernumber
      end if
    end if
  end if
end if
End Sub
Sub ONQUERY(Message,Nickname,Host,ServerNumber)
if left(lcase(Message),8) = "!answer " then
  if len(message) > 8 then
    channel = GetIniFile("trivia.ini","controls","channel","")
    Call answertrivia(mid(lcase(message),9),channel,nickname,servernumber)
  else
    SendCommand "/notice " & nickname & " You did not supply an answer.", servernumber
  end if
end if
if left(lcase(Message),10) = "!addtrivia" then 
  admin = GetIniFile("trivia.ini","controls","admins","")
  if Instr(lcase(admin),lcase(Nickname)) then
    if len(message) > 11 then
      Call addtrivia(mid(Message,12),nickname,servernumber)
    else
      SendCommand "/notice " & Nickname & " You did not supply enough information, Im afraid.", servernumber
    end if
  else
    contact = GetIniFile("trivia.ini","controls","contact","")
    SendCommand "/notice " & Nickname & " " & contact, servernumber
  end if
end if
End Sub

Sub answertrivia(message,channel,nickname,servernumber)
Dim rndnum
Dim nextquestion
Dim total
checkwait = GetIniFile("trivia.ini","controls","wait","stop")
if lcase(checkwait) = "stop" then
  roundinterval = GetIniFile("trivia.ini","controls","roundinterval","0")
  SendCommand "/notice " & nickname & " Next round in less than " & roundinterval & " seconds.", servernumber
else
  roundinterval = GetIniFile("trivia.ini","controls","roundinterval","0")
  current = GetIniFile("trivia.ini","controls","current","0")
  answer = GetIniFile("trivia.ini","answers",current,"")
  question = GetIniFile("trivia.ini","questions",current,"")
  if lcase(message) = lcase(answer) then
    SendCommand "/msg " & channel & " " & nickname & " answered the question correctly!", servernumber
    SendCommand "/msg " & channel & " Question: " & question, servernumber
    SendCommand "/msg " & channel & " Answer: " & answer, servernumber
    SendCommand "/msg " & channel & " New round in " & int(roundinterval) & " seconds.", servernumber
    userscore = int(GetIniFile("trivia.ini","scores",lcase(nickname),"0")) + 1
    highscore = int(GetIniFile("trivia.ini","controls","highscore","0"))
    if int(userscore) > int(highscore) then
      WriteIniFile "trivia.ini","controls","highnick",nickname
      WriteIniFile "trivia.ini","controls","highscore",userscore
    end if
    WriteIniFile "trivia.ini","scores",lcase(nickname),userscore
    total = GetIniFile("trivia.ini","controls","total","0")
    rndnum = Int(Rnd * total) + 1
    if int(rndnum) = int(current) then
      if total = 1 then
        nextquestion = 1
      else
        nextquestion = rndnum - 1
      end if
    else
      nextquestion = int(rndnum)
    end if
    if int(nextquestion) = o then
      nextquestion=1
    end if
    WriteIniFile "trivia.ini","controls","current",nextquestion
    WriteIniFile "trivia.ini","controls","wait","stop"
    SendCommand "/timer newtriviaround 1 " & roundinterval & " /! newtriviaround " & nextquestion & " | " & channel & " | " & servernumber & "", ServerNumber
  else
    SendCommand "/notice " & nickname & " Incorrect.", servernumber
  end if
end if
End Sub

Sub newtriviaround(current,channel,servernumber)
WriteIniFile "trivia.ini","controls","wait","go"
question = GetIniFile("trivia.ini","questions",current,"")
SendCommand "/msg " & channel & " New Round! " & question,servernumber
End Sub
Sub addtrivia(content,nickname,servernumber)

if Instr(content,"#") then
  temp1 = instr(content,"#")
  answer = Mid(content,temp1+1)
  question = Mid(content,1,temp1 - 2)
  control = GetIniFile("trivia.ini","controls","total","0") + 1
  if len(answer) > 0 then
    WriteIniFile "trivia.ini","controls","total","" & control & ""
    WriteIniFile "trivia.ini","questions","" & control & "","" & question & ""
    WriteIniFile "trivia.ini","answers","" & control & "","" & answer & ""
    SendCommand "/notice " & Nickname & " Added. Count is " & control & "", ServerNumber
  else
    SendCommand "/notice " & Nickname & " Syntax error. !addtrivia <question> #<answer>", ServerNumber
  end if
  else
    SendCommand "/notice " & Nickname & " Syntax error. !addtrivia <question> #<answer>", ServerNumber
end if

End Sub

Sub topicupdate()
SendCommand "/timer topiccontrol off"
topiccontrol = GetIniFile("trivia.ini","options","topiccontrol","no")
if lcase(topiccontrol) = "yes" then
  pretopic = GetIniFile("trivia.ini","options","pretopic","Come Play trivia!")
  topic = pretopic
  disp_topic_total = GetIniFile("trivia.ini","options","disp_topic_total","no")
  if lcase(disp_topic_total) = "yes" then
    total = GetIniFile("trivia.ini","controls","total","0")
    topic = topic & " - We have " & total & " Questions."
  end if
  disp_topic_high = GetIniFile("trivia.ini","options","disp_topic_high","no")
  if lcase(disp_topic_high) = "yes" then
    nick = GetIniFile("trivia.ini","controls","highnick","0")
    score = GetIniFile("trivia.ini","controls","highscore","0")
    topic = topic & " - Highscore: " & nick & " - " & score
  end if
  WriteIniFile "trivia.ini","options","topic_new",topic
  oldtopic = GetIniFile("trivia.ini","options","topic_old","")
  if lcase(topic) <> lcase(oldtopic) then
    channel = GetIniFile("trivia.ini","controls","channel","")
    networkname = GetIniFile("trivia.ini","controls","network","")
    SendCommand "/scid " & networkname & " /topic " & channel & " " & topic
    WriteIniFile "trivia.ini","options","topic_old",topic
  end if
  rate = GetIniFile("trivia.ini","options","topic_interval","60")
  SendCommand "/scid " & networkname & " /timer topiccontrol 1 " & rate & " /! topicupdate"
end if
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''

Sub addquestion()
question=InputBox("Add a Question:","Add a Question","")
if len(question) <> 0 then
  answer=InputBox("Add an answer to: " & question,"Add a Answer","")
  if len(answer) = 0 then
    SendCommand "/echo -a No Answer Specified."
  else
    current = getinifile("trivia.ini","controls","current","0")
    if current = 0 then
      writeinifile "trivia.ini","controls","current","1"
    end if
    control=GetIniFile("trivia.ini","controls","total","0") + 1
    WriteIniFile "trivia.ini","questions",control,question
    WriteIniFile "trivia.ini","answers",control,answer
    WriteIniFile "trivia.ini","controls","total",control
    SendCommand "/echo -a Question/Answer added as " & control
  end if
end if
End Sub

Sub Modquestion()
num=InputBox("What number?","Modify Questions / Answers","")
if num <> 0 and len(num) <> 0 then
  question = GetIniFile("trivia.ini","questions",num,"")
  answer = GetIniFile("trivia.ini","answers",num,"")
  question = InputBox("Question:","Modify Question",question)
  answer = InputBox("Answer:","Modify Answer",answer)
  WriteIniFile "trivia.ini","questions",num,question
  WriteIniFile "trivia.ini","answers",num,answer
  current = getinifile("trivia.ini","controls","current","0")
  if current = 0 then
    writeinifile "trivia.ini","controls","current","1"
  end if
  SendCommand "/echo Modified."
end if
End Sub

Sub edittriviaini()
directory = GetIdentifier("$icechatdir",ServerNumber)
RunShell directory & "scripts\trivia.ini"
End Sub

Dim triviamenu
Sub opentriviamenu()
check = getinifile("trivia.ini","controls","ini","no")
if lcase(check) = "no" then
writeinifile "trivia.ini","controls","wait","go"
writeinifile "trivia.ini","controls","total","0"
writeinifile "trivia.ini","controls","current","0"
writeinifile "trivia.ini","controls","ini","yes"
end if
triviamenu = CreateDialog("Trivia Menu",100,100,100,205)
AddButton triviamenu,"Channel",1,5,90,30,1,0,"channelbutton"
AddButton triviamenu,"Network",1,40,90,30,2,0,"networkbutton"
AddButton triviamenu,"Rounds",1,75,90,30,3,0,"roundbutton"
AddButton triviamenu,"Message",1,110,90,30,4,0,"messagebutton"
AddButton triviamenu,"Admins",1,145,90,30,5,0,"adminbutton"
AddButton triviamenu,"Topic",1,180,90,30,6,0,"topicbutton"
ShowDialog triviamenu
End Sub

Sub adminbutton_clicked()
var="admins"
message="These people will be able to use the !addtrivia command to add questions and answers to the database. Seperate multiple entries with a comma:"
title="Change Admins"
var = getinifile("trivia.ini","controls",var,"")
var = InputBox(message,title,var)
if len(var) > 0 then
writeinifile "trivia.ini","controls","admins",var
end if
End Sub

Sub channelbutton_clicked()
var="Channel"
message="Change which channel the script works on:"
title="Change Channel"
var = getinifile("trivia.ini","controls",var,"")
var = InputBox(message,title,var)
if len(var) > 0 then
writeinifile "trivia.ini","controls","channel",var
end if
End Sub

Sub networkbutton_clicked()
var="network"
message="Change which Network for the script works on:"
title="Change Network"
var = getinifile("trivia.ini","controls",var,"")
var = InputBox(message,title,var)
if len(var) > 0 then
writeinifile "trivia.ini","controls","network",var
end if
End Sub
Sub roundbutton_clicked()
var="roundinterval"
message="How long In Between Questions?"
title="Change Rounds"
var = getinifile("trivia.ini","controls",var,"")
var = InputBox(message,title,var)
if len(var) > 0 then
writeinifile "trivia.ini","controls","roundinterval",var
end if
End Sub

Sub messagebutton_clicked()
var="contact"
message="Specify a message someone will see if they use the !addtrivia command and are not on the admins list:"
title="Change Message"
var = getinifile("trivia.ini","controls",var,"")
var = InputBox(message,title,var)
if len(var) > 0 then
writeinifile "trivia.ini","controls","contact",var
end if
End Sub

Sub topicbutton_clicked()
Call opentopicmenu()
End Sub

Dim triviatopicmenu
Sub opentopicmenu()
triviatopicmenu = CreateDialog("Trivia Topic Control",200,100,100,170)
AddCheckBox triviatopicmenu,"Enable?",1,5,80,15,1
AddCheckBox triviatopicmenu,"Count?",1,25,80,15,2
AddCheckBox triviatopicmenu,"Score?",1,45,80,15,3
AddButton triviatopicmenu,"Pre-Topic",1,75,90,30,4,0,"pretopicbutton"
AddButton triviatopicmenu,"Interval",1,110,90,30,5,0,"topicintervalbutton"
AddButton triviatopicmenu,"Update",1,145,90,30,6,0,"updatebutton"
ShowDialog triviatopicmenu
enable = getinifile("trivia.ini","options","topiccontrol","no")
if lcase(enable) = "yes" then
  CheckItem 1,6,1
end if
disp_total = getinifile("trivia.ini","options","disp_topic_total","no")
if lcase(disp_total) = "yes" then
  CheckItem 2,6,1
end if
disp_high = getinifile("trivia.ini","options","disp_topic_high","no")
if lcase(disp_high) = "yes" then
  CheckItem 3,6,1
end if
End Sub
Sub pretopicbutton_clicked()
pretopic = GetIniFile("trivia.ini","options","pretopic","")
pretopic = InputBox("This is the message that will appear at the beginning of the topic.","Change Pre-Topic",pretopic)
writeinifile "trivia.ini","options","pretopic",pretopic
End Sub
Sub topicintervalbutton_clicked()
interval = getinifile("trivia.ini","options","topic_interval","30")
interval = InputBox("This is how frequesntly the topic will update (in seconds).","Change Topic Interval",interval)
writeinifile "trivia.ini","options","topic_interval",interval
End Sub
Sub updatebutton_clicked()
checkstate1 = ItemState(1,6)
checkstate2 = ItemState(2,6)
checkstate3 = ItemState(3,6)
if checkstate1 = 1 then
  writeinifile "trivia.ini","options","topiccontrol","yes"
else
  writeinifile "trivia.ini","options","topiccontrol","no"
end if
if checkstate2 = 1 then
  writeinifile "trivia.ini","options","disp_topic_total","yes"
else
  writeinifile "trivia.ini","options","disp_topic_total","no"
end if
if checkstate3 = 1 then
  writeinifile "trivia.ini","options","disp_topic_high","yes"
else
  writeinifile "trivia.ini","options","disp_topic_high","no"
end if
Call topicupdate()
End Sub

Sub opentriviahelpfile()
RunShell "trivia_help.txt"
End Sub













